object worksheet {
  type Conjunto[T] = T => Boolean
  
  val pares: Conjunto[Int] = (x: Int) => x % 2 == 0
                                                  //> pares  : Int => Boolean = <function1>

  def contem[T](conj: Conjunto[T], elem: T) = conj(elem)
                                                  //> contem: [T](conj: T => Boolean, elem: T)Boolean
  contem(pares, 2)                                //> res0: Boolean = true
  contem(pares, 7)                                //> res1: Boolean = false
  
  val stam1: Conjunto[String] = (s: String) => s.length == 1
                                                  //> stam1  : String => Boolean = <function1>

  contem(stam1, "a")                              //> res2: Boolean = true
  contem(stam1, "foo")                            //> res3: Boolean = false
  
  def comp[A, B, C](f: A => B, g: B => C): A => C =
    (x: A) => g(f(x))                             //> comp: [A, B, C](f: A => B, g: B => C)A => C

  def dobra[T](f: T => T): T => T = comp(f, f)    //> dobra: [T](f: T => T)T => T

  dobra((x: Int) => x * x)(3)                     //> res4: Int = 81
}